reset
#
# $Id: ucd_js3a.plt; 
#
j = {0,1}
w(f) = 2*pi*f
#
#
#
#      ------------H(w)-------------
#      |                           |
# in - + -- L(w) -- d(w) -- G(w) ---- out
#
#


# output filter G(w) constants and equation
L = 30e-6
C = 680e-9
ZL = 6
G(w) = ZL / (ZL + j*w*L - ZL*C*L*w*w)

# delay function d(w) (comparator + switching stage)
td = 200e-9
d(w) = exp(-j*w*td)

# Feedback function H(w)
RL = 100
RF = 22e3
RG = 1e3
CL = 390e-12
ta = RL * CL
tb = (RF+RL)*CL
An = RF/RG
H(w) = (1+j*w*tb) / ((1+j*w*tb) + An*(1+j*w*ta))

# loop filter (integrator or LAG-filter depending on component values)
# assume a first order roll-off in the OP
Aop(w) = 1e6/(1+j*w*1e-5)
RF1 = 5600
RF2 = 1000
CF2 = 1.5e-9
ZF(w)  = RF1 * (1+j*w*CF2*RF2) / (1+j*w*CF2*(RF1+RF2))
L(w) = 1/(RG/Aop(w)+RG/ZF(w))

# calculate LF loop gain and closed loop gain
# note: get Fsw from plot of loop phase
Fsw = 415e3
Av = 2/(pi*abs(G(w(Fsw))*H(w(Fsw))*L(w(Fsw))))
Al(w) = Av*L(w)*d(w)*G(w)*H(w)
Acl(w) = Av*L(w)*d(w)*G(w) / (1+Al(w))
An(w) = 1/(1+Al(w))

#commands to make the nice plot
set logscale x
set size 1,1
set lmargin 5
set origin 0.0,0.1
set multiplot
set size 0.9,0.4
set origin 0.0,0.1
plot [f=100:1e6] (180/pi)*arg(Acl(w(f))),(180/pi)*arg(Al(w(f)))
set size 0.9,0.4
set origin 0.0,0.5
set logscale y
plot [f=100:1e6] abs(Acl(w(f))),abs(Al(w(f))),abs(An(w(f)))
set nomultiplot
